/*
Ŀ
                                                                            
                               *  LINEDEL *                                 
                                                                            
                       LI'LL BBS - (33-1) 4082.9096                         
                               Paris - FRANCE                               
                       Ren Cougnenc & Attila Altan                         
                                                                            
    This utility will remove all the lines containing a predefined          
    serie of characters from any text file.                                 
                                                                            
    In short, it works pretty much like the DOS FIND /V command.            
                                                                            
    Compiler : Microsoft C : cl /Gs linedel.c                               
    --------------------------------------------                            
                                                                            
    I use this little utility to clean up my DOWNLOAD.TXT file from         
    entries that are not really necessary trying to keep it small !         
                                                                            

*/

#include <stdio.h>
#include <string.h>
#include <time.h>

#ifdef __TURBOC__                       /* Pff. Rhaa Borland de malheur...*/
#include <mem.h>
#else
#include <memory.h>
#endif

#ifndef __TURBOC__
#include <sys/types.h>
#endif
#include <sys/stat.h>


#define CONFIG_FILE   "LINEDEL.CFG"       /* Le fichier de config         */
#define TMP_PATH      "LINE$DEL.TMP"      /* WorkFile                     */
#define INDEX_FILE    "LINEDEL.IDX"       /* Le fichier de memorisation   */
#define COMMENT_CHAR  35                  /* Char de commentaire ligne: # */
#define MAXEXPR       50                  /* Nombre d'expressions max     */
#define SIZEXPR       40                  /* Nombre de chars max d'un mot */
#define MAXLINELEN    255                 /* Taille max d'une ligne...    */
#define BUFFERS       20000               /* Taille buffers fichiers      */
#define ERROR         0xFF
#define OK            0
#define SAME_FILE     1
#define TWO_FILES     0

char ConfigPath[127];     /* Le nom du fichier de config */
char ConfigIdx[1024];     /* Le nom du fichier d'index   */
char SourcePath[127];     /* Le nom du fichier  traiter */

char Expressions[ MAXEXPR ][ SIZEXPR ];   /* On lira la config dedans     */
int  NbExpr ;                             /* Nombre d'expressions a traiter*/
/* Attention : 1 based!          */

int FromStart = 0 ;                       /* Forcage au debut,ligne commande*/
long CfgTime  = 0L ;                      /* Date fichier config,meme raison*/

long GetStart();
long fsize();
long ftime();

struct IndexType
{
    char t[300];
    char fname[80];      /* Nom du fichier trait      */
    long Time;           /* Date du dernier traitement */
    long Offset;         /* Nombre d'octets traits    */
    long CfgTime;        /* Date du fichier de config  */
    char f[80];
}
Idx = {
    "Ceci est le fichier de mmorisation du travail effectu par\r\n"
	"linedel.exe.   En cas d'utilisation d'un fichier de config,\r\n"
	"supprimer ce fichier reviendra  faire reprendre depuis  le\r\n"
	"dbut le prochain traitement. Poil aux dents.              \r\n"
	"                              \r\n",
    "",
    0L,
    0L,
    0L,
    "\r\nVous venez de voir les donnes :-)\r\n"

};

/*-------------------------------------------------------------------------*/

main(int argc, char **argv)
{
    int i;

    MakeConfPath(argv[0]);

    if( TestUsage( argv[1] ) )             /* demande l'aide...      */
	return ( OK );

    if( TestFromStart( argc,argv ) )       /* Force travail au dbut.*/
    {
	argc --;
	FromStart = 1 ;
    }

    CopyRight();

    switch( argc )
    {
    case 1 : /*--- Pas d'argument, utilisation fichier de config ----*/

	if( ( NbExpr = ReadConf()) == 0  )
	    return( ERROR );

	if( ! Work(SourcePath,TMP_PATH ,SAME_FILE ))
	    return( ERROR );

	break;

    case 3 : /*---- Ligne de commande, 1 seul fichier --------------*/

	NbExpr = argc - 2 ;
	for( i = 2; i < argc ; i++ )  /* Je suis bete, je pensais traiter     */
	{                             /* plusieurs arguments, mais on peut pas*/
	    strcpy(Expressions[i-2],argv[i] );
	    strupr(Expressions[i-2]);
	}
	if( ! Work(argv[1],TMP_PATH ,SAME_FILE ))
	    return( ERROR );

	break;

    case 4 : /*---- Ligne de commande,2 fichiers spars -----------*/

	NbExpr = argc - 3 ;
	for( i = 3; i < argc ; i++ )
	{
	    strcpy(Expressions[i-3],argv[i] );
	    strupr(Expressions[i-3]);
	}
	if( ! Work(argv[1],argv[2],TWO_FILES ))
	    return( ERROR );

	break;

    default :
	printf("Syntax Error !%c\n",7);
	return( ERROR );
    }

    Epilogue();
    return( OK );
}
/*-------------------------------------------------------------------------*/




/*-----------------------------------------------------------------------
 *         Cre le nom du fichier de configuration   lire, en prenant
 *         le path d'appel du programme comme chemin d'accs.
*/
MakeConfPath(char *path)
{
    int i;

    strcpy(ConfigPath,path);
    strcpy(ConfigIdx, path);

    i = strlen(ConfigPath);
    while(i)
    {
	if(ConfigPath[i] == '\\' || ConfigPath[i] == ':') break ;
	ConfigPath[i] = 0;
	i--;
    }
    strcat( ConfigPath,CONFIG_FILE );


    i = strlen(ConfigIdx);
    while(i)
    {
	if(ConfigIdx[i] == '\\' || ConfigIdx[i] == ':') break ;
	ConfigIdx[i] = 0;
	i--;
    }
    strcat( ConfigIdx,INDEX_FILE );
}
/*----------------------------------------------------------------------*/




/*-----------------------------------------------------------------------
 *         Lit le fichier de config, place les expressions dans le
 *         tableau.
 *         Retourne le nombre d'expressions  traiter, ou 0 en cas
 *         D'erreur.
*/

ReadConf()
{
    FILE *fichier;
    char tmp[ MAXLINELEN + 1];
    int count;

    CfgTime = ftime ( ConfigPath);
    fichier = fopen(ConfigPath,"rt");               /* Ouverture du fichier   */
    if(fichier == NULL)
    {
	printf("Unable to open file : %s\n",ConfigPath);
	return(0);
    }

    count = 0 ;
    printf("Reading Config...\r");
    while(fgets(tmp,MAXLINELEN,fichier ) )          /* Lecture du boulot...    */
    {
	FiltreLine(tmp );                             /* bug gets... :-)         */
	strupr(tmp );
	if(strlen(tmp) < 2 )        continue ;        /* Lignes vides limines */
	if(tmp[0] == COMMENT_CHAR ) continue ;
	if( ! count )                                 /* La premiere ligne est le*/
	{                                             /* fichier  traiter       */
	    strcpy(SourcePath,tmp);
	}
	else
	{
	    strcpy( Expressions[ count - 1 ],tmp );
	}

	count++ ;

	if( count >= MAXEXPR )
	{
	    printf("Too many KeyWords !!! Max = %d\n",MAXEXPR -1 );
	    fclose(fichier);
	    return(0);
	}
    }
    fclose(fichier);
    return( count - 1 );
}
/*--------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
/*
 *              Fonction Moulinette Principale du programme.
 *
 *     Retourne 0 en cas de problme, 1 si tout va bien.
*/

Work(char *src,char *dest,int SameFile)
{
    FILE *Source,*Cible;
    char tmp[ MAXLINELEN + 1 ] ;
    char lin[ MAXLINELEN + 1 ] ;
    long Start;
    char *WriteMode ;
    static char
	*Append = "at",
    *Creat  = "wt";

    int i,CountDel,FlagDel,TotLine;
    int TmpCount;


    if (FromStart) Start = 0L ;        /* Ou est ce qu'on commence donc .? */
    else
    {
	Start = GetStart();

	if(Start == fsize(src)  )
	{
	    printf("File %s unchanged...\n"
		"Nothing to do !\n\n",src);
	    return(0);
	}
    }

    if( Start != 0L )        /* Copie rapide du boulot dj effectu... */
    {
	printf("Fast copy of %ld bytes already processed...\n\n",Start);
	if(! fcopy(src,dest,Start ) )
	    return( 0 );
	WriteMode = Append;
    }
    else WriteMode = Creat;

    Source = fopen(src,"rt");
    if(Source == NULL)
    {
	printf("Unable to open file %s\n",src);
	return(0);
    }
    setvbuf(Source,NULL,_IOFBF,BUFFERS);



    if( fseek( Source,Start, 0 ) )
    {
	printf("Unable to seek %ld bytes\n",Start);
	fclose(Source);
	return(0);
    }

    Cible = fopen(dest,WriteMode);
    if(Cible == NULL)
    {
	printf("Unable to open temporary file %s\n",dest);
	return(0);
    }
    setvbuf(Cible,NULL,_IOFBF,BUFFERS);


    CountDel = 0 ;                       /* Nombre de lignes effaces  */
    TotLine  = 0 ;                       /* Nombre de lignes lues      */
    TmpCount = 0 ;                       /* Affiche de 10 en 10 lignes */

    while(fgets(lin, MAXLINELEN,Source ) )  /* Et hop on mouiline...   */
    {
	strcpy(tmp,lin);                    /* Recherche non case-sensitive*/
	strupr(tmp);
	for(i = 0 ; i < NbExpr; i++ )
	{
	    if ( fmatch (tmp,Expressions[i]) )
	    {
		FlagDel = 1;
		CountDel++;
		break ;
	    }
	    else FlagDel = 0 ;
	}

	if(!FlagDel)
	    fprintf(Cible,"%s",lin);

	TotLine ++ ;
	TmpCount++ ;
	if(TmpCount > 9 )
	{
	    TmpCount = 0 ;
	    printf("\r\tLigne : %d\r",TotLine);
	}
    }

    printf("\t  Prodessed lines : %d\n",TotLine  );
    printf("\t    Deleted lines : %d\n",CountDel );
    printf("\t              Now : %d %s\n",
    (TotLine - CountDel ),
    Start > 0L ? "more lines" : "lines" );

    fflush( Cible );
    Start = ftell(Cible);
    fclose( Source);
    fclose( Cible );

    if(SameFile)     /* On remet le meme nom de fichier donc , */
    {
	if( unlink(src) == -1 )
	{
	    printf("Access Denied !\n"
		"File unchanged, temporary file not removed.\n");
	    return(0);
	}

	if( rename(dest,src) == -1 )
	{
	    printf("Access denied !!!\n"
		"Temporary file not removed, original file deleted...\n"
		"Do it yourself...\n");
	    return(0);
	}
    }
    PutStart(Start);
    return(1);
}
/*-------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
/*
 *      Corrige le bug normalis des  fgets()... :-)
 *
*/

FiltreLine(char *line)
{
    line[strlen(line) -1 ] = 0 ;
}
/*-------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
/*
                    Gestion des expressions rgulires
                    ( from qnx utilities. )
*/
/*
 * Compare a string against a pattern and return 1 on a match.
 * The pattern argument may contain the meta-characters '*' and '?'
 * '*' will match zero or more charcters while '?' may be used
 * as a wild card which will match any one character.
 * A [ccc] will match a single char from the enclosed set.
 * Examples
 * '*.o'      match a string ending in '.o'
 * 'fred.*'   match a string starting in 'fred.'.
 * '*aa*'     match a string with an 'aa' in it.
 * 'tmp*c'    match a string starting with 'tmp' and ending in 'c'
 * '?'        match any single character
 * 'bill.?'   match a string starting with 'bill.' followed by a single char
 */


#define MATCH	1

fmatch(_fname, _pat)
char *_fname, *_pat;
{
    register char *pat, *fname;

    pat = _pat;
    fname = _fname;

    if(*pat++ == '*') {
	if(*pat == '\0')
	    return(MATCH);

	while(*fname)
	    if(match(fname++, pat))
		return(MATCH);

	return(0);
    }
    else
	return(match(fname, pat + -1));
}



static match(_fname, _pat)
char *_fname, *_pat;
{
    register char *pat, *fname;
    char not_flag, found_flag;

    pat = _pat;
    fname = _fname;

    while(*pat && *fname) {
	switch(*pat) {

	case '?':
	    break;

	case '[':
	    not_flag = *++pat == '^' ? 1 : 0;
	    found_flag = 0;

	    while(*pat  &&  *pat++ != ']')
		if(*(pat + -1) == *fname)
		    found_flag = 1;

	    if(found_flag == not_flag)
		return(0);

	    --pat;
	    break;

	case '*':
	    return(fmatch(fname, pat));

	default:
	    if(*pat != *fname)
		return(0);
	}

	++pat;
	++fname;
    }

    return((*pat == 0 || (*pat == '*' && *++pat == 0))  &&  *fname == 0 ? MATCH : 0);
}

/*-------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/*
 *                 Affiche le copyright du programme....
 *
*/
CopyRight()
{
    printf("\n\n"
	"͸\n"
	" LINEDEL  Attila Altan & Ren Cougnenc  1990 \n"
	"͵\n"
	"              File Clean-up utility            \n"
	"          LI'LL BBS - (33-1) 4082.9096         \n"
	"                Paris - FRANCE                 \n"
	"                Help : LINEDEL /h              \n"
	"[2.0];\n"
	"\n\n"
	);
}
/*-------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/*
 *              Prvient que c'est fini...
 *
*/
Epilogue()
{
    printf("\n\n"
	"The cleaning up of the file is done !\n"
	"\n");
    /*   "WAKE UP ! %c\n",7);*/
}
/*-------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------
 *         Regarde s'il le dernier argument n'est pas une demande
 *         de tout reprendre au dbut quoi qu'il arrive...
*/

TestFromStart(int argc,char **argv)
{
    char *arg;

    arg = argv[argc -1];  /* le dernier argument... */
    strupr(arg);          /* pour tre peinard...   */

    if(     fmatch( arg, "*/S*") ||   fmatch( arg, "*-S*" )  )
	return (1);
    return (0);
}


/*-----------------------------------------------------------------------
 *         Regarde s'il n'y a pas une demande d'aide dans la ligne
 *         de commande. si oui, affiche l'aide et retourne 1.
*/
TestUsage(char *arg)
{
    strupr(arg);  /* pour tre peinard... */
    if(     fmatch( arg, "*/H*") ||   fmatch( arg, "*/[?]*" ) ||
	fmatch( arg, "*-H*") ||   fmatch( arg, "*-[?]*" ) ||
	arg[0] == '?'
	)
    {
	printf("    LINEDEL - Attila Altan & Ren Cougnenc - LINEDEL Help file         \n");
	printf("-----------------------------------------------------------------------\n\n");
	printf(" 1) Without a flag : LINEDEL [/start]\n");
	printf("                    The program will use the config file LINEDEL.CFG,\n"
	    "                    (Read next page)\n\n");
	printf(" 2) With flags:\n"
	    "                       LINEDEL INPUT.TXT REMOVE\n\n");
	printf("    Will delete all the lines with the word REMOVE in them contained\n"
	    "    in the file called INPUT.TXT. The INPUT.TXT file is not saved.\n\n");

	printf("                       LINEDEL INPUT.TXT OUTPUT.TXT REMOVE\n\n"
	    "    Will copy INPUT.TXT into OUTPUT.TXT except for the lines that\n"
	    "    contain REMOVE in them. The original INPUT.TXT remains untouched.\n\n");

	printf("--- Hit a key to read the next page  --- ESC to cancel ---\r");
	if( getch() == 27 ) return(1);

	printf("\nWithout flags :\n\n");
	printf("The program will use a file called LINEDEL.CFG, in the directory\n"
	    "wher LINEDEL.EXE is located.\n");
	printf("This file is an ASCII file containing:\n"
	    " - The path/name of the file to clean-up,\n"
	    " - As many as %d lines with the 'words' to be removed.\n\n",MAXEXPR);
	printf("All the lines begining with a '#' will be considered as a comment line\n"
	    "and will be ignored.\n\n");
	printf("Sample LINEDEL.CFG file:\n\n");
	printf("#-- Comment\n"
	    "#                             Name & path of file to clean-up,\n"
	    "C:\\PCB\\MAIN\\DOWNLOAD.TXT\n"
	    "#                             Words to be removed,\n"
	    "*SYSOP*\n"
	    "*MAIL.*\n"
	    "*.[aio]\n"
	    "*a??ila*\n"
	    "#-- end of file\n\n");

	printf("--- Hit a key to read the next page --- ESC to cancel ---\r");
	if( getch() == 27 ) return(1);
	printf("\n\n\n\n\n\n\n\n");
	printf("Research for words to be removed is NOT case sensitive.\n\n"
	    "'Words' can be any ASCII characters and wildcards can be used\n"
	    "just like in DOS ('*' and '?') but can be placed anywhere in\n"
	    "the config file.\n\n");
	printf("For example, to remove all the lines containing ALLFILES.ZIP-\n"
	    "you have to create a line in the config file with *ALLFILES.ZIP*\n"
	    "or *ALLFILES.???* to remove the ALLFILES.EXE too ... etc etc \n\n\n\n\n\n\n");

	printf("--- Hit akey to read the next page --- ESC to cancel ---\r");
	if( getch() == 27 ) return(1);
	printf("\n\n\n\n\n\n");
	printf("Short description of the search function :\n"
	    "/*\n"
	    "   Compare a string against a pattern and return 1 on a match.\n"
	    "   The pattern argument may contain the meta-characters '*' and '?'\n"
	    "   '*' will match zero or more characters while '?' may be used\n"
	    "   as a wild card which will match any one character.\n"
	    "   A [ccc] will match a single char from the enclosed set.\n");
	printf("   Examples\n"
	    "   '*.o'      match a string ending in '.o'\n"
	    "   'fred.*'   match a string starting in 'fred.'.\n"
	    "   '*aa*'     match a string with an 'aa' in it.\n"
	    "   'tmp*c'    match a string starting with 'tmp' and ending in 'c'\n"
	    "   '?'        match any single character\n"
	    "   'bill.?'   match a string starting with 'bill.' followed by a single char\n"
	    "*/\n\n\n\n\n");

	printf("--- Hit any key to read the last page --- ESC to cancel ---\r");
	if( getch() == 27 ) return(1);

	printf("\n\n\n\n");
	printf("the /START flag.     ( /S or -S )\n");
	printf("----------------\n\n");
	printf("To shorten the excecution time of the program, LINEDEL keeps track of\n"
	    "the works done.\n");
	printf("As a result it will NOT treate the part of the file already scanned\n"
	    "since its last use with the config file.\n\n");
	printf("But it will start the scan from the begining if :\n\n");
	printf("      - You use the /S option.\n");
	printf("      - The config file's date has changed.\n");
	printf("      - The file to be cleaned-up is not the same as before.\n");
	printf("      - There's no config file.\n");
	printf("      - LINEDEL is used with flags (the config file is then ignored).\n");
	printf("      - The index file (linedel.idx) is deleted.\n");
	printf("        (LINEDEL will recreate it.)\n");
	printf("\n\n\n");




	return(1);
    }
    return(0);
}
/*---------------------------------------------------------------------------*/



/*-----------------------------------------------------------------------
 *         Enregistre dans le fichier idx la date et le nom du fichier du
 *         dernier traitement.
*/

PutStart(long Start)
{
    FILE *fp;
    long Time;

    time (&Time);

    if ( (fp = fopen(ConfigIdx,"wb" ) ) == NULL )
    {
	printf("Unable to create memo file %s\n",ConfigIdx);
	return;
    }

    Idx.Time   = Time  ;
    Idx.Offset = Start ;
    strcpy(Idx.fname,SourcePath);
    Idx.CfgTime = CfgTime;

    fwrite(&Idx.t[0],sizeof( struct IndexType),1,fp );
    fprintf(fp,"\r\nFile Created : %s\r\n",ctime( & Time ) );
    fclose(fp);
    printf("\t         Job Date : %s\n",ctime( & Time ) );
    return;
}

/*-----------------------------------------------------------------------
 *         Rcupre dans le fichier idx s'il existe, la date et le nom du
 *         fichier du dernier traitement.
 *         Retourne l'offset a partir duquel dmarrer le traitement.
 *         Retourne 0L ( traitement au dbut donc) si:
 *
 *          Ce n'est pas le mme fichier
 *
 *          Il n'y a pas de fichier mmo...
 *          La date est dbile.
 *          Le fichier de config a chang ( date... );
*/

long GetStart()
{
    FILE *fp;
    long TimeNow,
    TimeRef;
    struct tm *detail;
    struct tm tnow,tref;


    if ( (fp = fopen(ConfigIdx,"rb" ) ) == NULL )  /* Pas de memo,hop bye.*/
	return(0L);

    fread(&Idx.t[0],sizeof( struct IndexType),1,fp );
    fclose(fp);

    TimeRef = Idx.Time ;
    time ( & TimeNow );

    if( TimeRef > TimeNow )                /* Fichier venant du futur ! */
	return (0L) ;

    if( strcmp ( SourcePath,Idx.fname ) )  /* Pas le mme fichier...    */
	return (0L);

    if( Idx.CfgTime != CfgTime )           /* FIchier config a chang   */
	return( 0L );
    /* Bon, maintenant que les grosses choses sont  */
    /* vues, passons au detail de la date et heure. */

#ifdef OLD_VERSION
    /* Non, c'tait inutile, c'est pas ca qu'attila */
    /* voulait :-)                                  */

    detail = gmtime ( &TimeNow );
    memcpy(&tnow,detail,sizeof(struct tm ) );
    detail = gmtime ( &TimeRef );
    memcpy(&tref,detail,sizeof(struct tm ) );

    if( tref.tm_year != tnow.tm_year )   return( 0L ); /* Pas la mme annee */
    if( tref.tm_yday != tnow.tm_yday )   return( 0L ); /* Pas le mme jour  */
    /* de l'anne..      */
#endif

    return( ( long) Idx.Offset );       /* Ok ! c'est le meme jour.         */
}



#include <fcntl.h>
/*-----------------------------------------------------------------------
 *         Copie  la vitesse du systme de deux fichiers,jusqu'
 *         siz octets maximum.
*/

fcopy(char *source, char *destin,long siz )
{
    int src,
    dst;
    int perm = S_IREAD | S_IWRITE ;
    int acc  = O_RDWR | O_BINARY | O_CREAT | O_TRUNC ;
    int nb;
    long tot ;
    char buf[4096];

    if(  ( src  = open (source,O_RDONLY | O_BINARY) ) == -1 )
    {
	printf("Unable to read file %s\n",source );
	return( 0 );
    }

    if(  ( dst  = open (destin,acc,perm) ) == -1 )
    {
	printf("Unable to create file %s\n",source );
	return( 0 );
    }

    tot = 0L;
    while( (nb  = read ( src, buf, 4096 )) )
    {
	tot += (long) nb;
	if( tot > siz )
	{
	    write( dst,buf,(int) nb - (int)(tot - siz) );
	    break;
	}
	else  write( dst,buf,(int) nb );
    }
    close( src );
    close( dst );
    return( 1 );
}


/*-----------------------------------------------------------------------
 *         Retourne la taille d'un fichier
 *
*/

long fsize(char *path)
{
    FILE *fp;
    long siz;

    if(  (fp  = fopen ( path,"r" )) == NULL )
	return ( -1L);

    fseek( fp , 0L , 2 ) ;
    siz = ftell(fp);
    fclose(fp);
    return(siz);
}


/*-----------------------------------------------------------------------
 *         Retourne la  date Unix d'un fichier .
 *
*/

long ftime(char *path)
{
    long tim;
    struct stat sbuf;

    if( stat ( path,&sbuf) )
	return( 0L );

    tim = sbuf.st_atime;

    return(tim);
}

/*====================== FIN DU FICHIER / END OF FILE =======================*/

